searchData={"items":[{"type":"module","title":"GoogleApi.HomeGraph.V1","doc":"API client metadata for GoogleApi.HomeGraph.V1.","ref":"GoogleApi.HomeGraph.V1.html"},{"type":"function","title":"GoogleApi.HomeGraph.V1.discovery_revision/0","doc":"","ref":"GoogleApi.HomeGraph.V1.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Api.AgentUsers","doc":"API calls for all endpoints tagged `AgentUsers`.","ref":"GoogleApi.HomeGraph.V1.Api.AgentUsers.html"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Api.AgentUsers.homegraph_agent_users_delete/4","doc":"Unlinks the given third-party user from your smart home Action. All data related to this user will be deleted. For more details on how users link their accounts, see [fulfillment and authentication](https://developers.home.google.com/cloud-to-cloud/primer/fulfillment). The third-party user's identity is passed in via the `agent_user_id` (see DeleteAgentUserRequest). This request must be authorized using service account credentials from your Actions console project.","ref":"GoogleApi.HomeGraph.V1.Api.AgentUsers.html#homegraph_agent_users_delete/4"},{"type":"function","title":"Parameters - GoogleApi.HomeGraph.V1.Api.AgentUsers.homegraph_agent_users_delete/4","doc":"*   `connection` (*type:* `GoogleApi.HomeGraph.V1.Connection.t`) - Connection to server\n*   `agent_users_id` (*type:* `String.t`) - Part of `agentUserId`. Required. Third-party user ID.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:requestId` (*type:* `String.t`) - Request ID used for debugging.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.HomeGraph.V1.Api.AgentUsers.html#homegraph_agent_users_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.HomeGraph.V1.Api.AgentUsers.homegraph_agent_users_delete/4","doc":"*   `{:ok, %GoogleApi.HomeGraph.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.HomeGraph.V1.Api.AgentUsers.html#homegraph_agent_users_delete/4-returns"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Api.Devices","doc":"API calls for all endpoints tagged `Devices`.","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_query/3","doc":"Gets the current states in Home Graph for the given set of the third-party user's devices. The third-party user's identity is passed in via the `agent_user_id` (see QueryRequest). This request must be authorized using service account credentials from your Actions console project.","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_query/3"},{"type":"function","title":"Parameters - GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_query/3","doc":"*   `connection` (*type:* `GoogleApi.HomeGraph.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.HomeGraph.V1.Model.QueryRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_query/3-parameters"},{"type":"function","title":"Returns - GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_query/3","doc":"*   `{:ok, %GoogleApi.HomeGraph.V1.Model.QueryResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_query/3-returns"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_report_state_and_notification/3","doc":"Reports device state and optionally sends device notifications. Called by your smart home Action when the state of a third-party device changes or you need to send a notification about the device. See [Implement Report State](https://developers.home.google.com/cloud-to-cloud/integration/report-state) for more information. This method updates the device state according to its declared [traits](https://developers.home.google.com/cloud-to-cloud/primer/device-types-and-traits). Publishing a new state value outside of these traits will result in an `INVALID_ARGUMENT` error response. The third-party user's identity is passed in via the `agent_user_id` (see ReportStateAndNotificationRequest). This request must be authorized using service account credentials from your Actions console project.","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_report_state_and_notification/3"},{"type":"function","title":"Parameters - GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_report_state_and_notification/3","doc":"*   `connection` (*type:* `GoogleApi.HomeGraph.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_report_state_and_notification/3-parameters"},{"type":"function","title":"Returns - GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_report_state_and_notification/3","doc":"*   `{:ok, %GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_report_state_and_notification/3-returns"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_request_sync/3","doc":"Requests Google to send an `action.devices.SYNC` [intent](https://developers.home.google.com/cloud-to-cloud/intents/sync) to your smart home Action to update device metadata for the given user. The third-party user's identity is passed via the `agent_user_id` (see RequestSyncDevicesRequest). This request must be authorized using service account credentials from your Actions console project.","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_request_sync/3"},{"type":"function","title":"Parameters - GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_request_sync/3","doc":"*   `connection` (*type:* `GoogleApi.HomeGraph.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_request_sync/3-parameters"},{"type":"function","title":"Returns - GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_request_sync/3","doc":"*   `{:ok, %GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_request_sync/3-returns"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_sync/3","doc":"Gets all the devices associated with the given third-party user. The third-party user's identity is passed in via the `agent_user_id` (see SyncRequest). This request must be authorized using service account credentials from your Actions console project.","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_sync/3"},{"type":"function","title":"Parameters - GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_sync/3","doc":"*   `connection` (*type:* `GoogleApi.HomeGraph.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.HomeGraph.V1.Model.SyncRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_sync/3-parameters"},{"type":"function","title":"Returns - GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_sync/3","doc":"*   `{:ok, %GoogleApi.HomeGraph.V1.Model.SyncResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_sync/3-returns"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Connection","doc":"Handle Tesla connections for GoogleApi.HomeGraph.V1.","ref":"GoogleApi.HomeGraph.V1.Connection.html"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.HomeGraph.V1.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.HomeGraph.V1.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.HomeGraph.V1.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#get/3"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#head/3"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.HomeGraph.V1.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.HomeGraph.V1.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.HomeGraph.V1.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.HomeGraph.V1.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.HomeGraph.V1.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.HomeGraph.V1.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.HomeGraph.V1.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.HomeGraph.V1.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#options/3"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.HomeGraph.V1.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.HomeGraph.V1.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.HomeGraph.V1.Connection.html#post/4"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.HomeGraph.V1.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.HomeGraph.V1.Connection.html#put/4"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.HomeGraph.V1.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.HomeGraph.V1.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.HomeGraph.V1.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.HomeGraph.V1.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.HomeGraph.V1.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.HomeGraph.V1.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.HomeGraph.V1.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.HomeGraph.V1.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Connection.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId","doc":"Third-party device ID for one device.","ref":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.AgentDeviceId","doc":"*   `id` (*type:* `String.t`, *default:* `nil`) - Third-party device ID.","ref":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId","doc":"Alternate third-party device ID.","ref":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId","doc":"*   `agentId` (*type:* `String.t`, *default:* `nil`) - Project ID for your smart home Action.\n*   `deviceId` (*type:* `String.t`, *default:* `nil`) - Unique third-party device ID.","ref":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.Device","doc":"Third-party device definition.","ref":"GoogleApi.HomeGraph.V1.Model.Device.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.Device","doc":"*   `attributes` (*type:* `map()`, *default:* `nil`) - Attributes for the traits supported by the device.\n*   `customData` (*type:* `map()`, *default:* `nil`) - Custom device attributes stored in Home Graph and provided to your smart home Action in each [QUERY](https://developers.home.google.com/cloud-to-cloud/intents/query) and [EXECUTE](https://developers.home.google.com/cloud-to-cloud/intents/execute) intent. Data in this object has a few constraints: No sensitive information, including but not limited to Personally Identifiable Information.\n*   `deviceInfo` (*type:* `GoogleApi.HomeGraph.V1.Model.DeviceInfo.t`, *default:* `nil`) - Device manufacturer, model, hardware version, and software version.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Third-party device ID.\n*   `name` (*type:* `GoogleApi.HomeGraph.V1.Model.DeviceNames.t`, *default:* `nil`) - Names given to this device by your smart home Action.\n*   `notificationSupportedByAgent` (*type:* `boolean()`, *default:* `nil`) - Indicates whether your smart home Action will report notifications to Google for this device via ReportStateAndNotification. If your smart home Action enables users to control device notifications, you should update this field and call RequestSyncDevices.\n*   `otherDeviceIds` (*type:* `list(GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.t)`, *default:* `nil`) - Alternate IDs associated with this device. This is used to identify cloud synced devices enabled for [local fulfillment](https://developers.home.google.com/local-home/overview).\n*   `roomHint` (*type:* `String.t`, *default:* `nil`) - Suggested name for the room where this device is installed. Google attempts to use this value during user setup.\n*   `structureHint` (*type:* `String.t`, *default:* `nil`) - Suggested name for the structure where this device is installed. Google attempts to use this value during user setup.\n*   `traits` (*type:* `list(String.t)`, *default:* `nil`) - Traits supported by the device. See [device traits](https://developers.home.google.com/cloud-to-cloud/traits).\n*   `type` (*type:* `String.t`, *default:* `nil`) - Hardware type of the device. See [device types](https://developers.home.google.com/cloud-to-cloud/guides).\n*   `willReportState` (*type:* `boolean()`, *default:* `nil`) - Indicates whether your smart home Action will report state of this device to Google via ReportStateAndNotification.","ref":"GoogleApi.HomeGraph.V1.Model.Device.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.Device.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.Device.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.Device.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.Device.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.DeviceInfo","doc":"Device information.","ref":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.DeviceInfo","doc":"*   `hwVersion` (*type:* `String.t`, *default:* `nil`) - Device hardware version.\n*   `manufacturer` (*type:* `String.t`, *default:* `nil`) - Device manufacturer.\n*   `model` (*type:* `String.t`, *default:* `nil`) - Device model.\n*   `swVersion` (*type:* `String.t`, *default:* `nil`) - Device software version.","ref":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.DeviceNames","doc":"Identifiers used to describe the device.","ref":"GoogleApi.HomeGraph.V1.Model.DeviceNames.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.DeviceNames","doc":"*   `defaultNames` (*type:* `list(String.t)`, *default:* `nil`) - List of names provided by the manufacturer rather than the user, such as serial numbers, SKUs, etc.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Primary name of the device, generally provided by the user.\n*   `nicknames` (*type:* `list(String.t)`, *default:* `nil`) - Additional names provided by the user for the device.","ref":"GoogleApi.HomeGraph.V1.Model.DeviceNames.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.DeviceNames.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.DeviceNames.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.DeviceNames.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.DeviceNames.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.Empty","doc":"A generic empty message that you can re-use to avoid defining duplicated empty messages in your APIs. A typical example is to use it as the request or the response type of an API method. For instance: service Foo { rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty); }","ref":"GoogleApi.HomeGraph.V1.Model.Empty.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.Empty","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.Empty.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.Empty.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.Empty.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.Empty.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.Empty.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.QueryRequest","doc":"Request type for the [`Query`](#google.home.graph.v1.HomeGraphApiService.Query) call.","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequest.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.QueryRequest","doc":"*   `agentUserId` (*type:* `String.t`, *default:* `nil`) - Required. Third-party user ID.\n*   `inputs` (*type:* `list(GoogleApi.HomeGraph.V1.Model.QueryRequestInput.t)`, *default:* `nil`) - Required. Inputs containing third-party device IDs for which to get the device states.\n*   `requestId` (*type:* `String.t`, *default:* `nil`) - Request ID used for debugging.","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.QueryRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequest.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.QueryRequest.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput","doc":"Device ID inputs to QueryRequest.","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.QueryRequestInput","doc":"*   `payload` (*type:* `GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.t`, *default:* `nil`) - Payload containing third-party device IDs.","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload","doc":"Payload containing device IDs.","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.QueryRequestPayload","doc":"*   `devices` (*type:* `list(GoogleApi.HomeGraph.V1.Model.AgentDeviceId.t)`, *default:* `nil`) - Third-party device IDs for which to get the device states.","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.QueryResponse","doc":"Response type for the [`Query`](#google.home.graph.v1.HomeGraphApiService.Query) call. This should follow the same format as the Google smart home `action.devices.QUERY` [response](https://developers.home.google.com/cloud-to-cloud/intents/query). Example: ```json { \"requestId\": \"ff36a3cc-ec34-11e6-b1a0-64510650abcf\", \"payload\": { \"devices\": { \"123\": { \"on\": true, \"online\": true }, \"456\": { \"on\": true, \"online\": true, \"brightness\": 80, \"color\": { \"name\": \"cerulean\", \"spectrumRGB\": 31655 } } } } } ```","ref":"GoogleApi.HomeGraph.V1.Model.QueryResponse.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.QueryResponse","doc":"*   `payload` (*type:* `GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.t`, *default:* `nil`) - Device states for the devices given in the request.\n*   `requestId` (*type:* `String.t`, *default:* `nil`) - Request ID used for debugging. Copied from the request.","ref":"GoogleApi.HomeGraph.V1.Model.QueryResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.QueryResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.QueryResponse.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.QueryResponse.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.QueryResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload","doc":"Payload containing device states information.","ref":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.QueryResponsePayload","doc":"*   `devices` (*type:* `map()`, *default:* `nil`) - States of the devices. Map of third-party device ID to struct of device states.","ref":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice","doc":"The states and notifications specific to a device.","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice","doc":"*   `notifications` (*type:* `map()`, *default:* `nil`) - Notifications metadata for devices. See the **Device NOTIFICATIONS** section of the individual trait [reference guides](https://developers.home.google.com/cloud-to-cloud/traits).\n*   `states` (*type:* `map()`, *default:* `nil`) - States of devices to update. See the **Device STATES** section of the individual trait [reference guides](https://developers.home.google.com/cloud-to-cloud/traits).","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest","doc":"Request type for the [`ReportStateAndNotification`](#google.home.graph.v1.HomeGraphApiService.ReportStateAndNotification) call. It may include states, notifications, or both. States and notifications are defined per `device_id` (for example, \"123\" and \"456\" in the following example). Example: ```json { \"requestId\": \"ff36a3cc-ec34-11e6-b1a0-64510650abcf\", \"agentUserId\": \"1234\", \"payload\": { \"devices\": { \"states\": { \"123\": { \"on\": true }, \"456\": { \"on\": true, \"brightness\": 10 } }, } } } ```","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest","doc":"*   `agentUserId` (*type:* `String.t`, *default:* `nil`) - Required. Third-party user ID.\n*   `eventId` (*type:* `String.t`, *default:* `nil`) - Unique identifier per event (for example, a doorbell press).\n*   `followUpToken` (*type:* `String.t`, *default:* `nil`) - Deprecated.\n*   `payload` (*type:* `GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.t`, *default:* `nil`) - Required. State of devices to update and notification metadata for devices.\n*   `requestId` (*type:* `String.t`, *default:* `nil`) - Request ID used for debugging.","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse","doc":"Response type for the [`ReportStateAndNotification`](#google.home.graph.v1.HomeGraphApiService.ReportStateAndNotification) call.","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse","doc":"*   `requestId` (*type:* `String.t`, *default:* `nil`) - Request ID copied from ReportStateAndNotificationRequest.","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest","doc":"Request type for the [`RequestSyncDevices`](#google.home.graph.v1.HomeGraphApiService.RequestSyncDevices) call.","ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest","doc":"*   `agentUserId` (*type:* `String.t`, *default:* `nil`) - Required. Third-party user ID.\n*   `async` (*type:* `boolean()`, *default:* `nil`) - Optional. If set, the request will be added to a queue and a response will be returned immediately. This enables concurrent requests for the given `agent_user_id`, but the caller will not receive any error responses.","ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse","doc":"Response type for the [`RequestSyncDevices`](#google.home.graph.v1.HomeGraphApiService.RequestSyncDevices) call. Intentionally empty upon success. An HTTP response code is returned with more details upon failure.","ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload","doc":"Payload containing the state and notification information for devices.","ref":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload","doc":"*   `devices` (*type:* `GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.t`, *default:* `nil`) - The devices for updating state and sending notifications.","ref":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.SyncRequest","doc":"Request type for the [`Sync`](#google.home.graph.v1.HomeGraphApiService.Sync) call.","ref":"GoogleApi.HomeGraph.V1.Model.SyncRequest.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.SyncRequest","doc":"*   `agentUserId` (*type:* `String.t`, *default:* `nil`) - Required. Third-party user ID.\n*   `requestId` (*type:* `String.t`, *default:* `nil`) - Request ID used for debugging.","ref":"GoogleApi.HomeGraph.V1.Model.SyncRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.SyncRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.SyncRequest.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.SyncRequest.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.SyncRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.SyncResponse","doc":"Response type for the [`Sync`](#google.home.graph.v1.HomeGraphApiService.Sync) call. This should follow the same format as the Google smart home `action.devices.SYNC` [response](https://developers.home.google.com/cloud-to-cloud/intents/sync). Example: ```json { \"requestId\": \"ff36a3cc-ec34-11e6-b1a0-64510650abcf\", \"payload\": { \"agentUserId\": \"1836.15267389\", \"devices\": [{ \"id\": \"123\", \"type\": \"action.devices.types.OUTLET\", \"traits\": [ \"action.devices.traits.OnOff\" ], \"name\": { \"defaultNames\": [\"My Outlet 1234\"], \"name\": \"Night light\", \"nicknames\": [\"wall plug\"] }, \"willReportState\": false, \"deviceInfo\": { \"manufacturer\": \"lights-out-inc\", \"model\": \"hs1234\", \"hwVersion\": \"3.2\", \"swVersion\": \"11.4\" }, \"customData\": { \"fooValue\": 74, \"barValue\": true, \"bazValue\": \"foo\" } }] } } ```","ref":"GoogleApi.HomeGraph.V1.Model.SyncResponse.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.SyncResponse","doc":"*   `payload` (*type:* `GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.t`, *default:* `nil`) - Devices associated with the third-party user.\n*   `requestId` (*type:* `String.t`, *default:* `nil`) - Request ID used for debugging. Copied from the request.","ref":"GoogleApi.HomeGraph.V1.Model.SyncResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.SyncResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.SyncResponse.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.SyncResponse.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.SyncResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload","doc":"Payload containing device information.","ref":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.html"},{"type":"module","title":"Attributes - GoogleApi.HomeGraph.V1.Model.SyncResponsePayload","doc":"*   `agentUserId` (*type:* `String.t`, *default:* `nil`) - Third-party user ID\n*   `devices` (*type:* `list(GoogleApi.HomeGraph.V1.Model.Device.t)`, *default:* `nil`) - Devices associated with the third-party user.","ref":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.html#module-attributes"},{"type":"function","title":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.html#decode/2"},{"type":"type","title":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.t/0","doc":"","ref":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}